function [Rbar,D,F]=rangj3(N1,N2,N3,rmin)
% [Rbar,D,F]=rangj3(N1,N2,N3,rmin)
% P.Comon, 22 May 2006.
% Rbar is the generic rank of tensors of order 3 and dimensions (N1,N2,N3) 
% and D is the dimension of the whole space of square tensors
% F is the dimension of the variety of solutions
% if a norm constraint is imposed on K-1 loading vectors in each term, F=Rbar*(N1+N2+N3-2)-D
% rmin is a lower bound on the generic rank, if known. The default is 1.

if nargin==3, rmin=1;end; % yet unused
I1=eye(N1,N1);I2=eye(N2,N2);I3=eye(N3,N3);JAC=[];

 rankold=0;ranknew=1;
 while ranknew>rankold,
  a=randn(1,N1);b=randn(1,N2);c=randn(1,N3);
  JAC=[JAC;kron(I1,kron(b,c));kron(a,kron(I2,c));kron(a,kron(b,I3))];
 temp=ranknew;ranknew=rank(JAC);
% temp=ranknew;[Q,U]=gsm(JAC);ranknew=rank(U);
 fprintf('ranknew=%i\n',ranknew)
 rankold=temp;
 end;
 D=ranknew;
 Rbar=0;D=0;

[lign,col]=size(JAC);Rbar=lign/(N1+N2+N3)-1;F=Rbar*(N1+N2+N3-2)-D;

