function [Rbar,D]=rangjs(N,d)
% [Rbar,D]=rangjs(N,d)
% Rbar is the generic rank of symmetric tensors of order d and dimension N, 
% and D is the dimension of the whole space of symmetric tensors
% F=N*Rbar-D is the dimension of the variety of solutions
% P.Comon, 10 January 1996; modified for scilab 20 may 2006.
% Call:
% for i=2:5,for j=3:4,M(i-2,j-2)=rangjs(i,j);end;end;M
% NB: limited to d=3 or d=4 and to N<7 for reasons of numerical complexity

I=eye(N,N); JAC=[];
if d==3,
 rankold=0;ranknew=1;
 while ranknew>rankold,
  a=randn(1,N);
  JAC=[JAC;kron(I,kron(a,a))+kron(a,kron(I,a))+kron(a,kron(a,I))];
 temp=ranknew;[Q,U]=gsm(JAC);ranknew=rank(U);
 fprintf('ranknew=%i\n',ranknew)
 rankold=temp;
 end;
 D=ranknew;
elseif d==4,
 rankold=0;ranknew=1;
 while ranknew>rankold,
  a=randn(1,N);
  JAC=[JAC;kron(I,kron(a,kron(a,a)))+kron(a,kron(I,kron(a,a)))+kron(a,kron(a,kron(I,a)))+kron(a,kron(a,kron(a,I)))];
 temp=ranknew;[Q,U]=gsm(JAC);ranknew=rank(U);
 fprintf('ranknew=%i\n',ranknew)
 rankold=temp;
 end;
 D=ranknew;
else
 Rbar=0;D=0;
end;
[lign,col]=size(JAC);Rbar=lign/N-1;
F=Rbar*N-D;